//Smets-Wouters model from AER June 2007

var y, c, i, z, l, r, pic, q, rk, k, w, mu_p, mu_w,
    y_flex, c_flex, i_flex, z_flex, l_flex, r_flex, pic_flex, q_flex, rk_flex, k_flex, w_flex,
    e_g, e_b, e_i, e_a, e_p, e_w, e_r, leta_p, 
    dlGDP, dlCONS, dlINV, dlWAG, lHOURS, dlP, FEDFUNDS;

varexo eta_g, eta_b, eta_i, eta_a, eta_p, eta_r;

parameters lambda, sigma_c, varphi, delta, phi_p, alfa, psi, iota_p, xi_p, ep, sigma_l, phi_w, iota_w, xi_w, ew, rho, r_pic, r_y, r_dy,
            gy_ss, rrbar, picbar, lbar, gammabar,
            rhog, rhoga, rhob, rhoi, rhoa, rhop, mup, rhow, muw, rhor,
            sigg, sigb, sigi, siga, sigp, sigw, sigr, gpop;

//parameters lambda, gamma, sigma_c, beta, varphi, delta, phi_p, alfa, psi, iota_p, xi_p, ep, sigma_l, phi_w, iota_w, xi_w, ew, rho, r_pic, r_y, r_dy,
//            cy_ss, iy_ss, zy_ss, gy_ss, ky_ss, rk_ss, w_ss, wlc_ss, pic_ss, picbar, rrbar, lbar, gammabar,
//            rhog, rhoga, rhob, rhoi, rhoa, rhop, mup, rhow, muw, rhor,
//            sigg, sigb, sigi, siga, sigp, sigw, sigr;

    
lambda=0.71;
gammabar=0.43;
//gamma=1+gammabar/100;
sigma_c=1.39;
rrbar=0.16;
//beta=1/(1+rrbar/100);
varphi=5.48;
delta=0.025;
phi_p=1.61;
alfa=0.19;
psi=0.54;
iota_p=0.22;
xi_p=0.65;
ep=10;
sigma_l=1.92;
phi_w=1.5;
iota_w=0.59;
xi_w=0.73;
ew=10;
rho=0.81;
r_pic=2.04;
r_y=0.08;
r_dy=0.22;

gy_ss=0.18;
//rk_ss=((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100));

//w_ss=(alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa));
//ky_ss=phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa);
//iy_ss=((1+gammabar/100)-1+delta)*(phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa));
//zy_ss=(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))*(phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa));
//cy_ss=1-gy_ss-(((1+gammabar/100)-1+delta)*(phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa)));
//wlc_ss=(1-alfa)/alfa*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))*(phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa))/(1-gy_ss-(((1+gammabar/100)-1+delta)*(phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa))));

//w_ss=(alfa^alfa*(1-alfa)^(1-alfa)/phi_p*rk_ss^(-alfa))^(1/(1-alfa));
//ky_ss=phi_p*(alfa/(1-alfa)*w_ss/rk_ss)^(1-alfa);
//iy_ss=((1+gammabar/100)-1+delta)*ky_ss;
//zy_ss=rk_ss*ky_ss;
//cy_ss=1-gy_ss-iy_ss;
//wlc_ss=(1-alfa)/alfa*rk_ss*ky_ss/cy_ss;

lbar=-0.1;
picbar=0.81;
//pic_ss=1+picbar/100;
            
rhog=0.97;
rhoga=0.52;
rhob=0.18;
rhoi=0.71;
rhoa=0.95;
rhop=0.90;
mup=0.74;
rhow=0.97;
muw=0.88;
rhor=0.12;

sigg=0.52; 
sigb=0.24; //*10
sigi=0.45;
siga=0.45;
sigp=0.14;
sigw=0.24;
sigr=0.24;

gpop=0.373;


model(linear); 

//transformed parameters
# gamma=1+gammabar/100;
# beta=1/(1+rrbar/100);
# pic_ss=1+picbar/100;
# rk_ss=((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100));
# w_ss=(alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa));
# ky_ss=phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa);
# iy_ss=((1+gammabar/100)-1+delta)*(phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa));
# zy_ss=(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))*(phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa));
# cy_ss=1-gy_ss-(((1+gammabar/100)-1+delta)*(phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa)));
# wlc_ss=(1-alfa)/alfa*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))*(phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa))/(1-gy_ss-(((1+gammabar/100)-1+delta)*(phi_p*(alfa/(1-alfa)*((alfa^alfa*(1-alfa)^(1-alfa)/phi_p*(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100)))^(-alfa))^(1/(1-alfa)))/(((1+gammabar/100)^sigma_c-(1/(1+rrbar/100))*(1-delta))/(1/(1+rrbar/100))))^(1-alfa))));

//resource constraint
y=cy_ss*c+iy_ss*i+zy_ss*z+e_g;
y_flex=cy_ss*c_flex+iy_ss*i_flex+zy_ss*z_flex+e_g;

//consumption Euler equation
c=lambda/gamma/(1+lambda/gamma)*c(-1)+(1-lambda/gamma/(1+lambda/gamma))*c(+1)+(sigma_c-1)*wlc_ss/sigma_c/(1+lambda/gamma)*(l-l(+1))-(1-lambda/gamma)/sigma_c/(1+lambda/gamma)*(r-pic(+1)+e_b);
c_flex=lambda/gamma/(1+lambda/gamma)*c_flex(-1)+(1-lambda/gamma/(1+lambda/gamma))*c_flex(+1)+(sigma_c-1)*wlc_ss/sigma_c/(1+lambda/gamma)*(l_flex-l_flex(+1))-(1-lambda/gamma)/sigma_c/(1+lambda/gamma)*(r_flex-pic_flex(+1)+e_b);

//investment Euler Equation
i=1/(1+beta*gamma^(1-sigma_c))*i(-1)+(1-1/(1+beta*gamma^(1-sigma_c)))*i(+1)+1/(1+beta*gamma^(1-sigma_c))/gamma^2/varphi*q+e_i;
i_flex=1/(1+beta*gamma^(1-sigma_c))*i_flex(-1)+(1-1/(1+beta*gamma^(1-sigma_c)))*i_flex(+1)+1/(1+beta*gamma^(1-sigma_c))/gamma^2/varphi*q_flex+e_i;

//value of capital
q=beta*gamma^(-sigma_c)*(1-delta)*q(+1)+(1-beta*gamma^(-sigma_c)*(1-delta))*rk(+1)-(r-pic(+1)+e_b);
q_flex=beta*gamma^(-sigma_c)*(1-delta)*q_flex(+1)+(1-beta*gamma^(-sigma_c)*(1-delta))*rk_flex(+1)-(r_flex-pic_flex(+1)+e_b);

//aggregate production function
y=phi_p*(alfa*(k(-1)+z)+(1-alfa)*l+e_a);
y_flex=phi_p*(alfa*(k_flex(-1)+z_flex)+(1-alfa)*l_flex+e_a);

//optimal capital utilization
z=(1-psi)/psi*rk;
z_flex=(1-psi)/psi*rk_flex;

//kapital accumulation
k=(1-delta)/gamma*k(-1)+(1-(1-delta)/gamma)*i+(1-(1-delta)/gamma)*(1+beta*gamma^(1-sigma_c))*gamma^2*varphi*e_i;
k_flex=(1-delta)/gamma*k_flex(-1)+(1-(1-delta)/gamma)*i_flex+(1-(1-delta)/gamma)*(1+beta*gamma^(1-sigma_c))*gamma^2*varphi*e_i;

//price mark-up
mu_p=alfa*(k(-1)+z-l)+e_a-w;
0=alfa*(k_flex(-1)+z_flex-l_flex)+e_a-w_flex;

//Phillips curve
pic=iota_p/(1+beta*gamma^(1-sigma_c)*iota_p)*pic(-1)+beta*gamma^(1-sigma_c)/(1+beta*gamma^(1-sigma_c)*iota_p)*pic(+1)-1/(1+beta*gamma^(1-sigma_c)*iota_p)*(1-beta*gamma^(1-sigma_c)*xi_p)*(1-xi_p)/xi_p/((phi_p-1)*ep+1)*mu_p+e_p;

//cost minimisation
rk=-(k(-1)+z-l)+w; //Error in S-W? Original: rk=-(k-l)+w;
rk_flex=-(k_flex(-1)+z_flex-l_flex)+w_flex;

//wage mark-up
mu_w=w-(sigma_l*l+1/(1-lambda/gamma)*(c-lambda/gamma*c(-1))); //Error in S-W? Original: mu_w=w-(sigma_l*l+1/(1-lambda)*(c-lambda*c(-1)))
0=w_flex-(sigma_l*l_flex+1/(1-lambda/gamma)*(c_flex-lambda/gamma*c_flex(-1))); 

//wage curve
w=1/(1+beta*gamma^(1-sigma_c))*w(-1)+(1-1/(1+beta*gamma^(1-sigma_c)))*(w(+1)+pic(+1))-(1+beta*gamma^(1-sigma_c)*iota_w)/(1+beta*gamma^(1-sigma_c))*pic+iota_w/(1+beta*gamma^(1-sigma_c))*pic(-1)-1/(1+beta*gamma^(1-sigma_c))*(1-beta*gamma^(1-sigma_c)*xi_w)*(1-xi_w)/xi_w/((phi_w-1)*ew+1)*mu_w+e_w;

//monetary policy reaction function
r=rho*r(-1)+(1-rho)*(r_pic*pic+r_y*(y-y_flex))+r_dy*((y-y_flex)-(y(-1)-y_flex(-1)))+e_r;
pic_flex=0;

//Exogenous Shocks
e_g=rhog*e_g(-1)+eta_g+rhoga*eta_a;
e_b=rhob*e_b(-1)+eta_b;
e_i=rhoi*e_i(-1)+eta_i;
e_a=rhoa*e_a(-1)+eta_a;
e_p=rhop*e_p(-1)+leta_p-mup*leta_p(-1);
e_w=0;//e_w=rhow*e_w(-1)+leta_w-muw*leta_w(-1);
e_r=rhor*e_r(-1)+eta_r;

leta_p=eta_p;
//leta_w=eta_w;

//Observables
dlGDP=gammabar+(y-y(-1))+gpop;
dlCONS=gammabar+(c-c(-1))+gpop;
dlINV=gammabar+(i-i(-1))+gpop;
dlWAG=gammabar+(w-w(-1));
lHOURS=lbar+(l);
dlP=picbar+(pic);
FEDFUNDS=100*(beta^(-1)*gamma^sigma_c*pic_ss-1)+(r);

end; 

initval;
y=0;
c=0;
i=0;
z=0;
l=0;
r=0;
pic=0;
q=0;
rk=0;
k=0;
w=0;
mu_p=0;
mu_w=0;
y_flex=0;
c_flex=0;
i_flex=0;
z_flex=0;
l_flex=0;
r_flex=0;
pic_flex=0;
q_flex=0;
rk_flex=0;
k_flex=0;
w_flex=0;
e_g=0;
e_b=0;
e_i=0;
e_a=0;
e_p=0;
e_w=0;
e_r=0;
leta_p=0;
//leta_w=0;
dlGDP=gammabar;
dlCONS=gammabar;
dlINV=gammabar;
dlWAG=gammabar;
lHOURS=lbar;
dlP=picbar;
FEDFUNDS=100*((1/(1+rrbar/100))^(-1)*(1+gammabar/100)^sigma_c*(1+picbar/100)-1);
end;

varobs dlGDP dlCONS dlINV lHOURS dlP FEDFUNDS;

steady;
check;

//shocks;
//var eta_g=sigg^2;
//var eta_b=sigb^2;
//var eta_i=sigi^2;
//var eta_a=siga^2;
//var eta_p=sigp^2;
//var eta_w=sigw^2;
//var eta_r=sigr^2;
//end;

estimated_params;
varphi, normal_pdf, 4.0, 1.5;
sigma_c, normal_pdf, 1.5, 0.37;
lambda, beta_pdf, 0.7, 0.1;
xi_w, beta_pdf, 0.5, 0.1;
sigma_l, normal_pdf, 2.0, 0.75;
xi_p, beta_pdf, 0.5, 0.1;
iota_w, beta_pdf, 0.5, 0.15;
iota_p, beta_pdf, 0.5, 0.15;
psi, beta_pdf, 0.5, 0.15;
phi_p, normal_pdf, 1.25, 0.12;
r_pic, normal_pdf, 1.5, 0.25;
rho, beta_pdf, 0.75, 0.1;
r_y, normal_pdf, 0.12, 0.05;
r_dy, normal_pdf, 0.12, 0.05;
picbar, gamma_pdf, 0.62, 0.1;
rrbar, gamma_pdf, 0.25, 0.1;
lbar, normal_pdf, 0.0, 2.0;
gammabar, normal_pdf, 0.4, 0.1;
alfa, normal_pdf, 0.3, 0.05;
stderr eta_a, inv_gamma_pdf, 0.4386, inf;
stderr eta_b, inv_gamma_pdf, 0.4386, inf;
stderr eta_g, inv_gamma_pdf, 0.4386, inf;
stderr eta_i, inv_gamma_pdf, 0.4386, inf;
stderr eta_r, inv_gamma_pdf, 0.4386, inf;
stderr eta_p, inv_gamma_pdf, 0.4386, inf;
//stderr eta_w, inv_gamma_pdf, 0.4386, inf;
rhoa, beta_pdf, 0.5, 0.2;
rhob, beta_pdf, 0.5, 0.2;
rhog, beta_pdf, 0.5, 0.2;
rhoi, beta_pdf, 0.5, 0.2;
rhor, beta_pdf, 0.5, 0.2;
rhop, beta_pdf, 0.5, 0.2;
//rhow, beta_pdf, 0.5, 0.2;
mup, beta_pdf, 0.5, 0.2;
//muw, beta_pdf, 0.5, 0.2;
rhoga, beta_pdf, 0.5, 0.2;
end;

estimated_params_bounds;
varphi, 0, 100;
sigma_c, 0, 10;
sigma_l, 0, 10;
lambda, 0, 1;
xi_p, 0, 1;
iota_p, 0, 1;
xi_w, 0, 1;
iota_w, 0, 1;
psi, 0, 1;
phi_p, 0, 10;
rho, 0, 1;
r_pic, -10, 10;
r_y, -10, 10;
r_dy, -10, 10;
gammabar, -100, 100;
rrbar, 0, 10;
picbar, 0, 10;
alfa, 0, 1;
rhoa, 0, 1;
rhob, 0, 1;
rhog, 0, 1;
rhoi, 0, 1;
rhor, 0, 1;
rhop, 0, 1;
rhoga, 0, 1;
mup, 0, 1;
end;

load options_dsge;
options_.datafile=datafile;
//recursive scheme 
options_.nobs      = nobs;
options_.first_obs = 1;
// rolling scheme
//options_.nobs      = 119;
//options_.first_obs = nobs - 118;


estimation(mode_compute=4,datafile='datafile',nodiagnostic,mh_replic=31250,mh_nblocks=4,mh_jscale=0.35,mh_drop=0.2,bayesian_irf,irf=40) dlGDP dlCONS dlINV dlWAG lHOURS dlP FEDFUNDS y pic r;



